#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "graphics.h"
#include "msdos.h"

#define T1right1 1
#define T1right2 2
#define T2right1 3
#define T2right2 4
#define T3right1 5
#define T3right2 6
#define FENCE 7
#define TAMAGOTCHI1 1
#define TAMAGOTCHI2 2
#define TAMAGOTCHI3 3

void MUESTRA_SPRITE (WORD cor_x, WORD cor_y, BYTE num_sprite);
void BORRA_SPRITE (WORD cor_x, WORD cor_y);
void MUEVE_TAMAGOTCHI (WORD cor_x, WORD cor_y, BYTE num_sprite);

void main (void)
{
 WORD mueve;
 WORD x1, y1, x2, y2, x3, y3;

 randomize ();
 MODO_VIDEO (VGA);

 COLOR_PALETA (1, 11, 11, 11);
 COLOR_PALETA (2, 63, 58, 45);
 COLOR_PALETA (3, 63, 63, 63);
 COLOR_PALETA (4, 0, 60, 0);
 COLOR_PALETA (5, 63, 0, 0);

 x1 = 0;
 y1 = 50;
 x2 = 0;
 y2 = 100;
 x3 = 0;
 y3 = 150;

 LINEA (316, 0, 316, 199, 5);
 LINEA (317, 0, 317, 199, 5);

 mueve = 0;
 do
 {
  MUESTRA_SPRITE (mueve, 30, FENCE);
  MUESTRA_SPRITE (mueve, 77, FENCE);
  MUESTRA_SPRITE (mueve, 127, FENCE);
  MUESTRA_SPRITE (mueve, 180, FENCE);
  mueve = mueve + 16;
 } while (mueve <= 300);

 do {
 mueve = random (4);

 switch (mueve)
 {
  case TAMAGOTCHI1:
  BORRA_SPRITE (x1, y1);
  MUEVE_TAMAGOTCHI (x1, y1, TAMAGOTCHI1);
  x1 = x1+2;
  break;

  case TAMAGOTCHI2:
  BORRA_SPRITE (x2, y2);
  MUEVE_TAMAGOTCHI (x2, y2, TAMAGOTCHI2);
  x2 = x2+2;
  break;

  case TAMAGOTCHI3:
  BORRA_SPRITE (x3, y3);
  MUEVE_TAMAGOTCHI (x3, y3, TAMAGOTCHI3);
  x3 = x3+2;
  break;
 }

 } while (x1 <= 300 && x2 <= 300 && x3 <= 300);

 LEE_CARACTER ();
 MODO_VIDEO (MSDOS);
}

void MUESTRA_SPRITE (WORD cor_x, WORD cor_y, BYTE num_sprite)
{
 WORD x, y, k;
 BYTE color;

 FILE *FICHERO;

 x = 0;
 y = 1;

 switch (num_sprite)
 {
  case T1right1:
  FICHERO = fopen ("T1RIGHT1.SPR", "r");
  fseek (FICHERO, 0, SEEK_SET);
  break;

  case T1right2:
  FICHERO = fopen ("T1RIGHT2.SPR", "r");
  fseek (FICHERO, 0, SEEK_SET);
  break;

  case T2right1:
  FICHERO = fopen ("T2RIGHT1.SPR", "r");
  fseek (FICHERO, 0, SEEK_SET);
  break;

  case T2right2:
  FICHERO = fopen ("T2RIGHT2.SPR", "r");
  fseek (FICHERO, 0, SEEK_SET);
  break;

  case T3right1:
  FICHERO = fopen ("T3RIGHT1.SPR", "r");
  fseek (FICHERO, 0, SEEK_SET);
  break;

  case T3right2:
  FICHERO = fopen ("T3RIGHT2.SPR", "r");
  fseek (FICHERO, 0, SEEK_SET);
  break;

  case FENCE:
  FICHERO = fopen ("FENCE.SPR", "r");
  fseek (FICHERO, 0, SEEK_SET);
  break;
  }

 for (k = 1; k <= 300; k++)
 {
  SIGUIENTE:
  color = getc (FICHERO);
  x++;

  if (color == 0x00)
  {
   goto SIGUIENTE;
  }

  if (color == 0x78)
  {
   x = 0;
   y++;
   goto SIGUIENTE;
  }

  if (color == 0xFE)
  goto FIN;

  PON_PIXEL (cor_x+x, cor_y+y, color);
 }

 FIN:
 fclose (FICHERO);
}

void BORRA_SPRITE (WORD cor_x, WORD cor_y)
{
 WORD x,y;
 for (y = cor_y; y <= cor_y+16; y++)
 {
  for (x = cor_x; x <= cor_x+14; x++)
   PON_PIXEL (x, y, 0);
 }
}

void MUEVE_TAMAGOTCHI (WORD cor_x, WORD cor_y, BYTE num_sprite)
{
 switch (num_sprite)
 {
  case TAMAGOTCHI1:
   MUESTRA_SPRITE (cor_x, cor_y, T1right1);
   delay (40);
   BORRA_SPRITE (cor_x, cor_y);
   MUESTRA_SPRITE (cor_x+1, cor_y, T1right2);
   delay (40);
   BORRA_SPRITE (cor_x+1, cor_y);
   MUESTRA_SPRITE (cor_x+2, cor_y, T1right1);
  break;

  case TAMAGOTCHI2:
   MUESTRA_SPRITE (cor_x, cor_y, T2right1);
   delay (40);
   BORRA_SPRITE (cor_x, cor_y);
   MUESTRA_SPRITE (cor_x+1, cor_y, T2right2);
   delay (40);
   BORRA_SPRITE (cor_x+1, cor_y);
   MUESTRA_SPRITE (cor_x+2, cor_y, T2right1);
  break;

  case TAMAGOTCHI3:
   MUESTRA_SPRITE (cor_x, cor_y, T3right1);
   delay (40);
   BORRA_SPRITE (cor_x, cor_y);
   MUESTRA_SPRITE (cor_x+1, cor_y, T3right2);
   delay (40);
   BORRA_SPRITE (cor_x+1, cor_y);
   MUESTRA_SPRITE (cor_x+2, cor_y, T3right1);
  break;
 }
}