	//PROGRAMA CODIFICADOR/DESCODIFICADOR
	//PARA USAR CON BORLAND C/C++ Y TURBO C

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>

void code (char *input, char *output, char start);
void decode (char *input, char *output, char start);

void main (int _argc, char *_argv[])
{
 if (_argc != 5)
 {
  printf ("Uso: Entrada Salida ENCODE/DECODE Letra de desplazamiento\n");
  exit (1);
 }

 if (!isalpha (*_argv[4]))
 {
  printf ("La letra de comienzo debe ser un carcter alfabtico\n");
  exit (1);
 }

 if (toupper (*_argv[3] == 'E'))
  code (_argv[1], _argv[2], *_argv[4]);
 else decode (_argv[1], _argv[2], *_argv[4]);
}

void code (char *input, char *output, char start)
{
 int ch;
 FILE *fp1, *fp2;

 if ((fp1 = fopen (input, "r")) == NULL)
 {
  printf ("No puedo abrir el archivo de entrada\n");
  exit (1);
 }

 if ((fp2 = fopen (output, "w")) == NULL)
 {
  printf ("No puedo abrir el archivo de salida\n");
  exit (1);
 }

 start = tolower (start);
 start = start - 'a';
 do
 {
  ch = getc (fp1);
  ch = tolower (ch);
  if (isalpha (ch))
  {
   ch+=start; 	//DESPLAZA LA LETRA
   if (ch > 'z') ch-=26; 	//VUELTA A EMPEZAR
  }
  putc (ch, fp2);
  if (feof (fp1)) break;
 } while (!ferror (fp1) && !ferror (fp2));
 fclose (fp1);
 fclose (fp2);
}

void decode (char *input, char *output, char start)
{
 int ch;
 FILE *fp1, *fp2;

 if ((fp1 = fopen (input, "r"))==NULL)
 {
  printf ("No puedo abrir archivo de entrada\n");
  exit (1);
 }

 if ((fp2 = fopen (output, "w"))==NULL)
 {
  printf ("No puedo abrir archivo de salida\n");
  exit (1);
 }

 start = tolower (start);
 start = start - 'a';
 do
 {
  ch = getc (fp1);
  ch = tolower (ch);
  if (isalpha (ch))
  {
   ch-=start;	//DESPLAZA UNA LETRA DEL ORIGINAL
   if (ch < 'a')
    ch+=26;	//VUELTA A EMPEZAR
  }
  putc (ch, fp2);
  if (feof(fp1)) break;
 } while (!ferror (fp1) && !ferror (fp2));
 fclose (fp1);
 fclose (fp2);
}