#include <stdio.h>
#include <alloc.h>
#include "graficos.h"
#include "teclado.h"

#define LEFT 1
#define RIGHT 2
#define BACKLEFT 3
#define BACKRIGHT 4
#define MASKLEFT 5
#define MASKRIGHT 6


void MUESTRA_SPRITE (WORD cor_x, WORD cor_y, BYTE num_sprite);
void BAILA (WORD x, WORD y);

void main (void)
{
 MODO_VIDEO (VGA);

 COLOR_PALETA (1, 0, 0, 0);
 COLOR_PALETA (2, 63, 55, 31);
 COLOR_PALETA (3, 31, 39, 63);

 RELLENA_PANTALLA (3);

 MUESTRA_SPRITE (160, 100, RIGHT);
 MUESTRA_SPRITE (175, 100, LEFT);
 MUESTRA_SPRITE (160, 120, BACKRIGHT);
 MUESTRA_SPRITE (175, 120, BACKLEFT);

 BAILA (50, 50);

 LEE_CARACTER ();
 MODO_VIDEO (MSDOS);
}

void MUESTRA_SPRITE (WORD cor_x, WORD cor_y, BYTE num_sprite)
{
 WORD x, y, k;
 BYTE color;

 FILE *FICHERO;

 x = 0;
 y = 1;

 switch (num_sprite)
 {
  case RIGHT:
  FICHERO = fopen ("RIGHT.SPR", "r");
  fseek (FICHERO, 0, SEEK_SET);
  break;

  case LEFT:
  FICHERO = fopen ("LEFT.SPR", "r");
  fseek (FICHERO, 0, SEEK_SET);
  break;

  case BACKRIGHT:
  FICHERO = fopen ("BACKRIGH.SPR", "r");
  fseek (FICHERO, 0, SEEK_SET);
  break;

  case BACKLEFT:
  FICHERO = fopen ("BACKLEFT.SPR", "r");
  fseek (FICHERO, 0, SEEK_SET);
  break;

  case MASKRIGHT:
  FICHERO = fopen ("MASKRIGH.SPR", "r");
  fseek (FICHERO, 0, SEEK_SET);
  break;

  case MASKLEFT:
  FICHERO = fopen ("MASKLEFT.SPR", "r");
  fseek (FICHERO, 0, SEEK_SET);
  break;
  }

 for (k = 1; k <= 182; k++)
 {
  SIGUIENTE:
  color = getc (FICHERO);
  x++;

  if (color == 0x00)
  {
   goto SIGUIENTE;
  }

  if (color == 0x78)
  {
   x = 0;
   y++;
   goto SIGUIENTE;
  }

  if (color == 0xFE)
  goto FIN;

  PON_PIXEL (cor_x+x, cor_y+y, color);
 }

 FIN:
 fclose (FICHERO);
}

void BAILA (WORD x, WORD y)
{
 WORD k;

 for (k = x; k <= x+24; k+=4)
 {
  MUESTRA_SPRITE (k, y, LEFT);
  delay (375);
  MUESTRA_SPRITE (k, y, MASKLEFT);
  MUESTRA_SPRITE (k+1, y, RIGHT);
  delay (375);
  MUESTRA_SPRITE (k+1, y, MASKRIGHT);
  MUESTRA_SPRITE (k+2, y, BACKLEFT);
  delay (375);
  MUESTRA_SPRITE (k+2, y, MASKLEFT);
  MUESTRA_SPRITE (k+3, y, BACKRIGHT);
  delay (375);
  MUESTRA_SPRITE (k+3, y, MASKRIGHT);
 }

 for (k = x+24; k >= x; k-=4)
 {
  MUESTRA_SPRITE (k, y, RIGHT);
  delay (375);
  MUESTRA_SPRITE (k, y, MASKRIGHT);
  MUESTRA_SPRITE (k-1, y, LEFT);
  delay (375);
  MUESTRA_SPRITE (k-1, y, MASKLEFT);
  MUESTRA_SPRITE (k-2, y, BACKRIGHT);
  delay (375);
  MUESTRA_SPRITE (k-2, y, MASKRIGHT);
  MUESTRA_SPRITE (k-3, y, BACKLEFT);
  delay (375);
  MUESTRA_SPRITE (k-3, y, MASKLEFT);
 }
}