#include <stdio.h>
#include "graphics.h"

void ESPIRAL_COLORES (WORD x, WORD y, WORD rad)
{
 WORD x2, y2, color;
 float deg = 0.005;
 float rad2;

 for (rad2 = 0; rad2 <= rad; rad2=rad2+0.05)
 {
  x2 = (rad2*cos(deg));
  y2 = (rad2*sin(deg));
  PON_PIXEL (x+x2, y+y2, color);
  deg = deg+0.015;
  if (color < 255)
   color++;
  else
   color = 1;
 }
}

void main (void)
{
 WORD x, y;

 MODO_VIDEO (VGA);

 for (x = 0; x <= 119; x++)
  COLOR_PALETA (x, 50*x/119, 0, 0);
 for (x = 120; x <= 219; x++)
  COLOR_PALETA (x, 50+(x-120)*13/99, (x-120)*63/99, 0);
 for (x = 220; x <= 255; x++)
  COLOR_PALETA (x,63, 63, (x-220)*63/35);

 ESPIRAL_COLORES (100, 100, 70);

 while (!kbhit ())
  ROTA_PALETA (0, 254);

 MODO_VIDEO (MSDOS);
}