#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "graphics.h"

// n de bioformos
#define NUM_BF 250

// estructura (variables) de los biomorfos
struct bioformo {
 int cor_x;
 int cor_y;
 unsigned char pigmentacion;
} mundo[NUM_BF];

// funcin para controlar las mutaciones
void muta (void)
{
 unsigned char color;
 int biof, k;

 k = random (2);
 biof = random (NUM_BF + 1);

 if (k == 0)
  if (mundo[biof].pigmentacion < 63)
   mundo[biof].pigmentacion++;

 if (k == 1)
  if (mundo[biof].pigmentacion > 0)
   mundo[biof].pigmentacion--;

 PON_PIXEL (mundo[biof].cor_x, mundo[biof].cor_y, mundo[biof].pigmentacion);
}

void main (void)
{
 register int cont;

 MODO_VIDEO (VGA);
 randomize ();

 //los primeros 63 colores son los tonos de verde de los biomorfos
 for (cont = 0; cont <= 63; cont++)
  COLOR_PALETA (cont, 0, cont, 0);

 //crea los biomorfos en posiciones aleatorias de la pantalla e igual pigmen.
 for (cont = 0; cont <= 99; cont++)
 {
  mundo[cont].cor_x = random (320);
  mundo[cont].cor_y = random (200);
  mundo[cont].pigmentacion = 31;
  PON_PIXEL (mundo[cont].cor_x, mundo[cont].cor_y, mundo[cont].pigmentacion);
 }

 do {
 muta ();
 } while (!kbhit ());

 LEE_CARACTER ();
 MODO_VIDEO (MSDOS);
}