#include <time.h>
#include <stdlib.h>
#include <stdio.h>
#include <dos.h>

#define BYTE unsigned char
#define WORD unsigned int
#define SI 1
#define NO 0

BYTE muerto;
BYTE caracter;
BYTE color_pixel;
WORD punk_x;
WORD punk_y;
FILE *fichero;

void MODO_VIDEO (BYTE modo)
{
 union REGS regs;
 regs.h.al = modo;
 regs.h.ah = 0;

 int86 (0x10, &regs, &regs);
}

void LEE_CARACTER (void)
{
 union REGS regs;
 regs.h.ah = 0x07;

 int86 (0x21, &regs, &regs);

 asm MOV	caracter, AL;
}

void PON_PIXEL (WORD cor_x, WORD cor_y, BYTE color)
{
 union REGS regs;
 regs.h.ah = 0x0C;
 regs.h.al = color;
 regs.x.cx = cor_x;
 regs.x.dx = cor_y;

 int86 (0x10, &regs, &regs);
}

void LEE_PIXEL (WORD cor_x, WORD cor_y)
{
 union REGS regs;
 regs.h.ah = 0x0D;
 regs.x.cx = cor_x;
 regs.x.dx = cor_y;

 int86 (0x10, &regs, &regs);
 asm MOV	color_pixel, AL;
}

void LEMMING_QUIETO (WORD cor_x, WORD cor_y)
{
 BYTE waiting;
 WORD x = cor_x;
 WORD k = 0;
 WORD y = cor_y;


 fichero = fopen ("waiting.dat", "rb");

 LEER:

 do
 {
  k++;
  x++;

  waiting = getc (fichero);

  if (waiting == 0xFE)
  {
   y = y + 1;
   x = cor_x;
   goto LEER;
  }
  if (waiting == 0xFF)
  {
   goto FIN;
  }

 PON_PIXEL (x, y, waiting);

 } while (waiting != 0xFF);

FIN:
fclose (fichero);
}

void LEMMING_PUNK_MUERTO (WORD cor_x, WORD cor_y)
{
 BYTE punkdead;
 WORD x = cor_x;
 WORD k = 0;
 WORD y = cor_y;


 fichero = fopen ("punkdead.dat", "rb");

 LEER:

 do
 {
  k++;
  x++;

  punkdead = getc (fichero);

  if (punkdead == 0xFE)
  {
   y = y + 1;
   x = cor_x;
   goto LEER;
  }
  if (punkdead == 0xFF)
  {
   goto FIN;
  }

 PON_PIXEL (x, y, punkdead);

 } while (punkdead != 0xFF);

FIN:
fclose (fichero);
}

void LEMMING_PUNK (WORD cor_x, WORD cor_y)
{
 BYTE punk;
 WORD x = cor_x;
 WORD k = 0;
 WORD y = cor_y;


 fichero = fopen ("punk.dat", "rb");

 LEER:

 do
 {
  k++;
  x++;

  punk = getc (fichero);

  if (punk == 0xFE)
  {
   y = y + 1;
   x = cor_x;
   goto LEER;
  }
  if (punk == 0xFF)
  {
   goto FIN;
  }

 PON_PIXEL (x, y, punk);

 } while (punk != 0xFF);

FIN:
fclose (fichero);
}

void LEMMING_PUNK_MUERTE (WORD cor_x, WORD cor_y, BYTE num_frame)
{
 BYTE punkdie;
 WORD x = cor_x;
 WORD k = 0;
 WORD y = cor_y;


 if (num_frame == 1)
  fichero = fopen ("punkdie1.dat", "rb");
 if (num_frame == 2)
  fichero = fopen ("punkdie2.dat", "rb");
 if (num_frame == 3)
  fichero = fopen ("punkdie3.dat", "rb");

 LEER:

 do
 {
  k++;
  x++;

  punkdie = getc (fichero);

  if (punkdie == 0xFE)
  {
   y = y + 1;
   x = cor_x;
   goto LEER;
  }
  if (punkdie == 0xFF)
  {
   goto FIN;
  }

 PON_PIXEL (x, y, punkdie);

 } while (punkdie != 0xFF);

FIN:
fclose (fichero);
}

void LEMMING_ARR (WORD cor_x, WORD cor_y, BYTE num_frame)
{
 BYTE walkup;
 WORD x = cor_x;
 WORD k = 0;
 WORD y = cor_y;


 if (num_frame == 1)
  fichero = fopen ("walkup1.dat", "rb");
 if (num_frame == 2)
  fichero = fopen ("walkup2.dat", "rb");
 if (num_frame == 3)
  fichero = fopen ("walkup3.dat", "rb");

 LEER:

 do
 {
  k++;
  x++;

  walkup = getc (fichero);

  if (walkup == 0xFE)
  {
   y = y + 1;
   x = cor_x;
   goto LEER;
  }
  if (walkup == 0xFF)
  {
   goto FIN;
  }

 PON_PIXEL (x, y, walkup);

 } while (walkup != 0xFF);

FIN:
fclose (fichero);
}

void LEMMING_ABA (WORD cor_x, WORD cor_y, BYTE num_frame)
{
 BYTE walkdwn;
 WORD x = cor_x;
 WORD k = 0;
 WORD y = cor_y;


 if (num_frame == 1)
  fichero = fopen ("walkdwn1.dat", "rb");
 if (num_frame == 2)
  fichero = fopen ("walkdwn2.dat", "rb");
 if (num_frame == 3)
  fichero = fopen ("walkdwn3.dat", "rb");

 LEER:

 do
 {
  k++;
  x++;

  walkdwn = getc (fichero);

  if (walkdwn == 0xFE)
  {
   y = y + 1;
   x = cor_x;
   goto LEER;
  }
  if (walkdwn == 0xFF)
  {
   goto FIN;
  }

 PON_PIXEL (x, y, walkdwn);

 } while (walkdwn != 0xFF);

FIN:
fclose (fichero);
}

void LEMMING_IZQ (WORD cor_x, WORD cor_y, BYTE num_frame)
{
 BYTE walkl;
 WORD x = cor_x;
 WORD k = 0;
 WORD y = cor_y;


 if (num_frame == 1)
  fichero = fopen ("walkl1.dat", "rb");
 if (num_frame == 2)
  fichero = fopen ("walkl2.dat", "rb");
 if (num_frame == 3)
  fichero = fopen ("walkl3.dat", "rb");

 LEER:

 do
 {
  k++;
  x++;

  walkl = getc (fichero);

  if (walkl == 0xFE)
  {
   y = y + 1;
   x = cor_x;
   goto LEER;
  }
  if (walkl == 0xFF)
  {
   goto FIN;
  }

 PON_PIXEL (x, y, walkl);

 } while (walkl != 0xFF);

FIN:
fclose (fichero);
}

void LEMMING_DER (WORD cor_x, WORD cor_y, BYTE num_frame)
{
 BYTE walkr;
 WORD x = cor_x;
 WORD k = 0;
 WORD y = cor_y;


 if (num_frame == 1)
  fichero = fopen ("walkr1.dat", "rb");
 if (num_frame == 2)
  fichero = fopen ("walkr2.dat", "rb");
 if (num_frame == 3)
  fichero = fopen ("walkr3.dat", "rb");

 LEER:

 do
 {
  k++;
  x++;

  walkr = getc (fichero);

  if (walkr == 0xFE)
  {
   y = y + 1;
   x = cor_x;
   goto LEER;
  }
  if (walkr == 0xFF)
  {
   goto FIN;
  }

 PON_PIXEL (x, y, walkr);

 } while (walkr != 0xFF);

FIN:
fclose (fichero);
}

void LEMMING_BORRA (WORD cor_x, WORD cor_y)
{
 WORD k, k2;

 k2 = cor_y;

 for (k = 0; k <= 7; k++)
 {
  if (k == 7)
  {
   k = 1;
   k2++;
  }

  if (k2 == (cor_y + 10))
  goto FIN;

  PON_PIXEL (cor_x + k, k2, 0);
 }
 FIN:
}

void MATA_LEMMING_PUNK (WORD cor_x, WORD cor_y)
{

  LEMMING_BORRA (cor_x, cor_y);

  LEMMING_PUNK_MUERTE (cor_x, cor_y, 1);
  delay (300);
  LEMMING_BORRA ( cor_x, cor_y);

  LEMMING_PUNK_MUERTE (cor_x, cor_y, 2);
  delay (300);
  LEMMING_BORRA (cor_x, cor_y);

  LEMMING_PUNK_MUERTE (cor_x, cor_y, 3);
  delay (300);
  LEMMING_BORRA (cor_x, cor_y);
  delay (300);

  LEMMING_PUNK_MUERTO (punk_x + 5, punk_y);
}

void MUEVE_LEMMING_ARR (WORD comienzo_y, WORD cor_x, WORD fin_y)
{
 WORD movimientos;

 movimientos = (comienzo_y - fin_y);

 do
 {
  movimientos--;

  LEMMING_BORRA (cor_x, fin_y + movimientos);

  LEMMING_ARR (cor_x, fin_y + movimientos, 1);
  delay (35);
  LEMMING_BORRA ( cor_x, fin_y + movimientos);

  LEMMING_ARR (cor_x, fin_y + movimientos, 2);
  delay (35);
  LEMMING_BORRA (cor_x, fin_y + movimientos);

  LEMMING_ARR (cor_x, fin_y + movimientos, 3);
  delay (35);
  LEMMING_BORRA (cor_x, fin_y + movimientos);
  delay (35);
 } while (movimientos >= 1);
}

void MUEVE_LEMMING_ABA (WORD comienzo_y, WORD cor_x, WORD fin_y)
{
 WORD movimientos;

 do
 {
  movimientos++;

  LEMMING_BORRA (cor_x, comienzo_y + movimientos);

  LEMMING_ABA (cor_x, comienzo_y + movimientos, 1);
  delay (35);
  LEMMING_BORRA (cor_x,comienzo_y + movimientos);

  LEMMING_ABA (cor_x, comienzo_y + movimientos, 2);
  delay (35);
  LEMMING_BORRA (cor_x, comienzo_y + movimientos);

  LEMMING_ABA (cor_x, comienzo_y + movimientos, 3);
  delay (35);
  LEMMING_BORRA (cor_x, comienzo_y + movimientos);
  delay (35);
 } while ((movimientos + comienzo_y) <= fin_y);
}

void MUEVE_LEMMING_IZQ (WORD comienzo_x, WORD cor_y, WORD fin_x)
{
 WORD movimientos;

 movimientos = (comienzo_x - fin_x);

 do
 {
  movimientos--;

  LEMMING_BORRA (fin_x + movimientos, cor_y);

  LEMMING_IZQ (fin_x + movimientos, cor_y, 1);
  delay (35);
  LEMMING_BORRA (fin_x + movimientos, cor_y);

  LEMMING_IZQ (fin_x + movimientos, cor_y, 2);
  delay (35);
  LEMMING_BORRA (fin_x + movimientos, cor_y);

  LEMMING_IZQ (fin_x + movimientos, cor_y, 3);
  delay (35);
  LEMMING_BORRA (fin_x + movimientos, cor_y);
  delay (35);
 } while (movimientos >= 1);
}

void MUEVE_LEMMING_DER (WORD comienzo_x, WORD cor_y, WORD fin_x)
{
 WORD movimientos;

 do
 {
  movimientos++;

  LEMMING_BORRA (comienzo_x + movimientos, cor_y);

  LEMMING_DER (comienzo_x + movimientos, cor_y, 1);
  delay (35);
  LEMMING_BORRA (comienzo_x + movimientos, cor_y);

  LEMMING_DER (comienzo_x + movimientos, cor_y, 2);
  delay (35);
  LEMMING_BORRA (comienzo_x + movimientos, cor_y);

  LEMMING_DER (comienzo_x + movimientos, cor_y, 3);
  delay (35);
  LEMMING_BORRA (comienzo_x + movimientos, cor_y);
  delay (35);
 } while ((movimientos + comienzo_x) <= fin_x);
}

void LEMMING_DISPARA (WORD cor_x, WORD cor_y)
{
 BYTE shooting;
 WORD x = cor_x;
 WORD k = 0;
 WORD y = cor_y;


 fichero = fopen ("shooting.dat", "rb");

 LEER:

 do
 {
  k++;
  x++;

  shooting = getc (fichero);

  if (shooting == 0xFE)
  {
   y = y + 1;
   x = cor_x;
   goto LEER;
  }
  if (shooting == 0xFF)
  {
   goto FIN;
  }

 PON_PIXEL (x, y, shooting);

 } while (shooting != 0xFF);

FIN:
for (x = x + 4; x <= 319; x++)
{
 PON_PIXEL (x, y - 3, 0x16);
 LEE_PIXEL (x + 1, y - 3);
 if (muerto == NO)
 {
  if (color_pixel == 0x0F || color_pixel == 0x04 || color_pixel == 0x14)
  {
   MATA_LEMMING_PUNK (punk_x, punk_y);
   muerto = SI;
   goto FIN2;
  }
 }
 delay (5);
 PON_PIXEL (x, y - 3, 0);
}

FIN2:
fclose (fichero);
}


void main (void)
{
 WORD x, y;

 randomize ();

 x = 160;
 y = 100;
 punk_x = random (300) + 20;
 punk_y = random (180) + 20;

 MODO_VIDEO (0x13);

 printf ("\n\n LEMMING v1.09\n");
 printf ("\n Por Diego Muoz Prez");
 printf ("\n\n Teclas:\n");
 printf ("Izq: O  Der: P  Arr: Q  Aba: A\n");
 printf ("Salir: X  Disparo: D");

 do
 {
  LEE_CARACTER ();

   LEMMING_BORRA (x + 2, y);
   LEMMING_BORRA (x - 2, y);
   LEMMING_BORRA (x, y - 2);
   LEMMING_BORRA (x, y + 2);

  if (caracter == 'o' || caracter == 'O')
  {
   MUEVE_LEMMING_IZQ (x, y, x - 2);
   x = x - 2;
   LEMMING_QUIETO (x - 1, y);
  }

  if (caracter == 'p' || caracter == 'P')
  {
   MUEVE_LEMMING_DER (x, y, x + 2);
   x = x + 2;
   LEMMING_QUIETO (x + 1, y);
  }

  if (caracter == 'q' || caracter == 'Q')
  {
   MUEVE_LEMMING_ARR (y, x, y - 2);
   y = y - 2;
   LEMMING_QUIETO (x, y - 1);
  }

  if (caracter == 'a' || caracter == 'A')
  {
   MUEVE_LEMMING_ABA (y, x, y + 3);
   y = y + 3;
   LEMMING_QUIETO (x, y + 1);
  }

  if (caracter == 'd' || caracter == 'D')
   LEMMING_DISPARA (x, y);

  if (caracter == 'x' || caracter == 'X')
  {
   MODO_VIDEO (0x03);
   exit (0);
  }
 if (muerto == NO)
  LEMMING_PUNK (punk_x, punk_y);
 } while (caracter != 'x' || caracter != 'X');
}