// Librera en C con rutinas variadas (leer caracteres, seleccionar, pginas
// de texto activas, intercambiar valores de 2 variables, etc.

#include <dos.h>

#define BYTE unsigned char
#define WORD unsigned int


// Funcin que lee un caracter sin mostrarlo por pantalla y retorna su n

BYTE LEE_CARACTER (void)
{
 BYTE caracter;
 asm MOV AH, 7
 asm INT 21h

 asm MOV caracter, AL
 return (caracter);
}


// Funcin que lee un caracter mostrndolo por pantalla y retorna su n

BYTE LEE_CARACTER_CON_ECHO (void)
{
 BYTE caracter;
 asm MOV AH, 1
 asm INT 21h

 asm MOV caracter, AL
 return (caracter);
}


// Funcin que fuerza una salida al MS-DOS

void SALIDA_DOS (void)
{
 asm MOV AX, 4C00h
 asm INT 21h
}

// Funcin que pone un caracter  con sus atributos en la pgina indicada

void PON_CARACTER (BYTE caracter, BYTE atributos, BYTE pagina, WORD num_veces)
{
 asm {
  MOV AH, 9h
  MOV BH, pagina
  MOV AL, caracter
  MOV BL, atributos
  MOV CX, num_veces
  INT 10h
 }
}


// Funcin para seleccionar la pgina de texto activa

void SEL_PAGINA_TEXTO (BYTE pagina)
{
 asm MOV AH, 5
 asm MOV AL, pagina
 asm INT 10h
}