// la base consiste en dibujar una linea en la parte inferior, de la que
// salen otras lineas de altura variable, y aplicar una interpolacion a dichas
// lneas

#include <stdio.h>
#include "graphics.h"
#include <stdlib.h>
#include <math.h>

void PON_PIXEL2 (WORD x, WORD y, BYTE color, BYTE *array)
{
 array[(y*320)+x] = color;
}

BYTE LEE_PIXEL2 (WORD x, WORD y, BYTE *array)
{
 return (array[(y*320)+x]);
}

void INTERPOLA2 (register WORD x, register WORD y, BYTE *array)
{
 register BYTE a, b, c, d;

 a = LEE_PIXEL2 (x-1, y, array);
 b = LEE_PIXEL2 (x+1, y, array);
 c = LEE_PIXEL2 (x, y-1, array);
 d = LEE_PIXEL2 (x, y+1, array);

 PON_PIXEL2 (x, y, (a+b+c+d)>>2, array);
}


void main (void)
{
 BYTE pant_virt[64000];

 register WORD x, y, y2, k2;

 MODO_VIDEO (VGA);

 for (x = 0; x < 64000; x++)
  pant_virt[x] = 0;

 for (x = 0; x <= 119; x++)
  COLOR_PALETA (x, 50*x/119, 0, 0);
 for (x = 120; x <= 219; x++)
  COLOR_PALETA (x, 50+(x-120)*13/99, (x-120)*63/99, 0);
 for (x = 220; x <= 255; x++)
  COLOR_PALETA (x,63, 63, (x-220)*63/35);

for (k2 = 0; k2 <= 130; k2++)
{
 for (x = 0; x <= 319; x+=2)
 {
  y = 199 - random (k2);
  for (y2 = 199; y2 >= y; y2--)
   PON_PIXEL2 (x, y2, y2-180, pant_virt);
 }

 for (x = 0; x <= 319; x++)
 {
  for (y = 70; y <= 199; y++)
   INTERPOLA2 (x, y, pant_virt);
 }

 for (x = 0; x <= 319; x++)
 {
  for (y = 70; y <= 180; y++)
   PON_PIXEL (x, y, LEE_PIXEL2 (x, y, pant_virt));
 }
}

for (;;)
{
 for (x = 0; x <= 319; x+=2)
 {
  y = 199 - random (140);
  for (y2 = 199; y2 >= y; y2--)
   PON_PIXEL2 (x, y2, y2-180, pant_virt);
 }

 for (x = 0; x <= 319; x++)
 {
  for (y = 50; y <= 199; y++)
   INTERPOLA2 (x, y, pant_virt);
 }

 for (x = 0; x <= 319; x++)
 {
  for (y = 50; y <= 180; y++)
   PON_PIXEL (x, y, LEE_PIXEL2 (x, y, pant_virt));
 }
}


 LEE_CARACTER ();
 MODO_VIDEO (MSDOS);
}