#include <stdio.h>
#include "teclado.h"
#include "graficos.h"

void PON_PIXEL_SVGA (WORD cor_x, WORD cor_y, BYTE color)
{
 WORD offset;
 offset = cor_x*cor_y*4;
 asm  MOV AX, 0A000h
 asm  MOV ES, AX
 asm  MOV AL, color
 asm  MOV CX, offset
 asm  MOV DI, CX
 asm  MOV ES:[DI], AL
}

void main (int _argc, char *_argv[])
{
 char paleta[769];
 WORD k;

 if (_argc != 2)
 {
  printf ("USO: FUNDSVGA.EXE Nombre de la paleta\n");
  SALIDA_DOS ();
 }

 MODO_VESA (SVGA640x480);

 for (k = 0; k <= 255; k++)
  COLOR_PALETA (k, 0, 0, 0);

 for (k = 0; k <= 255; k++)
  PON_PIXEL_SVGA (k, 100, k);

 CARGA_PALETA (_argv[1], paleta);

 FADE_IN (paleta);

 LEE_CARACTER ();

 FADE_OUT (paleta);

 MODO_VIDEO (MSDOS);
}