#include <stdio.h>
#include "graphics.h"
#include <stdlib.h>

void PON_PIXEL2 (WORD x, WORD y, BYTE color, BYTE *array)
{
 array[(y*320)+x] = color;
}

BYTE LEE_PIXEL2 (WORD x, WORD y, BYTE *array)
{
 return (array[(y*320)+x]);
}

void INTERPOLA2 (register WORD x, register WORD y, BYTE *array)
{
 register BYTE a, b, c, d;

 a = LEE_PIXEL2 (x-1, y, array);
 b = LEE_PIXEL2 (x+1, y, array);
 c = LEE_PIXEL2 (x, y-1, array);
 d = LEE_PIXEL2 (x, y+1, array);

 PON_PIXEL2 (x, y, (a+b+c+d)>>2, array);
}

void PON_M (register WORD x, register WORD y, register BYTE color, BYTE *array)
{
  PON_PIXEL2 (x, y, color, array);
  PON_PIXEL2 (x+1, y, color, array);
  PON_PIXEL2 (x+2, y, color, array);
  PON_PIXEL2 (x+3, y, color, array);
  PON_PIXEL2 (x+4, y, color, array);
  PON_PIXEL2 (x+5, y, color, array);
  PON_PIXEL2 (x+6, y, color, array);
  PON_PIXEL2 (x, y+1, color, array);
  PON_PIXEL2 (x+1, y+1, color, array);
  PON_PIXEL2 (x+3, y+1, color, array);
  PON_PIXEL2 (x+5, y+1, color, array);
  PON_PIXEL2 (x+6, y+1, color, array);
  PON_PIXEL2 (x, y+2, color, array);
  PON_PIXEL2 (x+1, y+2, color, array);
  PON_PIXEL2 (x+3, y+2, color, array);
  PON_PIXEL2 (x+5, y+2, color, array);
  PON_PIXEL2 (x+6, y+2, color, array);
  PON_PIXEL2 (x, y+3, color, array);
  PON_PIXEL2 (x+1, y+3, color, array);
  PON_PIXEL2 (x+5, y+3, color, array);
  PON_PIXEL2 (x+6, y+3, color, array);
  PON_PIXEL2 (x, y+4, color, array);
  PON_PIXEL2 (x+1, y+4, color, array);
  PON_PIXEL2 (x+2, y+4, color, array);
  PON_PIXEL2 (x+5, y+4, color, array);
  PON_PIXEL2 (x+6, y+4, color, array);
  PON_PIXEL2 (x, y+5, color, array);
  PON_PIXEL2 (x+1, y+5, color, array);
  PON_PIXEL2 (x+2, y+5, color, array);
  PON_PIXEL2 (x+5, y+5, color, array);
  PON_PIXEL2 (x+6, y+5, color, array);
  PON_PIXEL2 (x, y+6, color, array);
  PON_PIXEL2 (x+1, y+6, color, array);
  PON_PIXEL2 (x+2, y+6, color, array);
  PON_PIXEL2 (x+5, y+6, color, array);
  PON_PIXEL2 (x+6, y+6, color, array);
}

void PON_I (register WORD x, register WORD y, register BYTE color, BYTE *array)
{
  PON_PIXEL2 (x, y, color, array);
  PON_PIXEL2 (x+1, y, color, array);
  PON_PIXEL2 (x+2, y, color, array);
  PON_PIXEL2 (x+3, y, color, array);
  PON_PIXEL2 (x+4, y, color, array);
  PON_PIXEL2 (x+5, y, color, array);
  PON_PIXEL2 (x+6, y, color, array);
  PON_PIXEL2 (x+2, y+1, color, array);
  PON_PIXEL2 (x+3, y+1, color, array);
  PON_PIXEL2 (x+2, y+2, color, array);
  PON_PIXEL2 (x+3, y+2, color, array);
  PON_PIXEL2 (x+2, y+3, color, array);
  PON_PIXEL2 (x+3, y+3, color, array);
  PON_PIXEL2 (x+4, y+3, color, array);
  PON_PIXEL2 (x+2, y+4, color, array);
  PON_PIXEL2 (x+3, y+4, color, array);
  PON_PIXEL2 (x+4, y+4, color, array);
  PON_PIXEL2 (x+2, y+5, color, array);
  PON_PIXEL2 (x+3, y+5, color, array);
  PON_PIXEL2 (x+4, y+5, color, array);
  PON_PIXEL2 (x, y+6, color, array);
  PON_PIXEL2 (x+1, y+6, color, array);
  PON_PIXEL2 (x+2, y+6, color, array);
  PON_PIXEL2 (x+3, y+6, color, array);
  PON_PIXEL2 (x+4, y+6, color, array);
  PON_PIXEL2 (x+5, y+6, color, array);
  PON_PIXEL2 (x+6, y+6, color, array);
}

void PON_C (register WORD x, register WORD y, register BYTE color, BYTE *array)
{
  PON_PIXEL2 (x, y, color, array);
  PON_PIXEL2 (x+1, y, color, array);
  PON_PIXEL2 (x+2, y, color, array);
  PON_PIXEL2 (x+3, y, color, array);
  PON_PIXEL2 (x+4, y, color, array);
  PON_PIXEL2 (x+5, y, color, array);
  PON_PIXEL2 (x+6, y, color, array);
  PON_PIXEL2 (x, y+1, color, array);
  PON_PIXEL2 (x+1, y+1, color, array);
  PON_PIXEL2 (x+5, y+1, color, array);
  PON_PIXEL2 (x+6, y+1, color, array);
  PON_PIXEL2 (x, y+2, color, array);
  PON_PIXEL2 (x+1, y+2, color, array);
  PON_PIXEL2 (x, y+3, color, array);
  PON_PIXEL2 (x+1, y+3, color, array);
  PON_PIXEL2 (x+2, y+3, color, array);
  PON_PIXEL2 (x, y+4, color, array);
  PON_PIXEL2 (x+1, y+4, color, array);
  PON_PIXEL2 (x+2, y+4, color, array);
  PON_PIXEL2 (x, y+5, color, array);
  PON_PIXEL2 (x+1, y+5, color, array);
  PON_PIXEL2 (x+2, y+5, color, array);
  PON_PIXEL2 (x+5, y+5, color, array);
  PON_PIXEL2 (x+6, y+5, color, array);
  PON_PIXEL2 (x, y+6, color, array);
  PON_PIXEL2 (x+1, y+6, color, array);
  PON_PIXEL2 (x+2, y+6, color, array);
  PON_PIXEL2 (x+3, y+6, color, array);
  PON_PIXEL2 (x+4, y+6, color, array);
  PON_PIXEL2 (x+5, y+6, color, array);
  PON_PIXEL2 (x+6, y+6, color, array);
}

void main (void)
{
 register WORD x, y, k;

 BYTE pant_virt[64000];

 MODO_VIDEO (VGA);

 for (x = 0; x <= 119; x++)
  COLOR_PALETA (x, 50*x/119, 0, 0);
 for (x = 120; x <= 219; x++)
  COLOR_PALETA (x, 50+(x-120)*13/99, (x-120)*63/99, 0);
 for (x = 220; x <= 255; x++)
  COLOR_PALETA (x,63, 63, (x-220)*63/35);

 for (x = 0; x < 64000; x++)
  pant_virt[x] = 0;

 for (;;)
 {
  for (k = 0; k <= 294; k++)
  {
   PON_M (k, 100, 255, pant_virt);
   PON_I (k+8, 100, 255, pant_virt);
   PON_C (k+16, 100, 255, pant_virt);

   for (x = 0; x < 320; x++)
    for (y = 99; y < 110; y++)
     INTERPOLA2 (x, y, pant_virt);

   for (x = 0; x < 320; x++)
    for (y = 99; y < 110; y++)
     PON_PIXEL (x, y, LEE_PIXEL2 (x, y, pant_virt));

   for (x = 31680; x < 35200; x++)
    pant_virt[x] = 0;
  }

  for (k = 295; k > 0; k--)
  {
   PON_M (k, 100, 255, pant_virt);
   PON_I (k+8, 100, 255, pant_virt);
   PON_C (k+16, 100, 255, pant_virt);

   for (x = 0; x < 320; x++)
    for (y = 99; y < 110; y++)
     INTERPOLA2 (x, y, pant_virt);

   for (x = 0; x < 320; x++)
    for (y = 99; y < 110; y++)
     PON_PIXEL (x, y, LEE_PIXEL2 (x, y, pant_virt));

   for (x = 31680; x < 35200; x++)
    pant_virt[x] = 0;
  }
 }

 LEE_CARACTER ();
 MODO_VIDEO (MSDOS);
}